package strategy;

import java.util.List;

public class DogDatabase {

    public static void main(String[] args) {

        Dog snoopy = new Dog("Snoopy", "932034", "Beagle");
        Dog marmaduke = new Dog("Marmaduke", "384382", "Great Dane");
        Dog clifford = new Dog("Clifford, the Big Red Dog", "392023", "Big Red Dog");

        List<Dog> dogs = List.of(snoopy, marmaduke, clifford);

        Dog targetSnoopy = new Dog("Snoopy", "UNKNOWN", "UNKNOWN");
        Dog nameUnknown = new Dog("UNKNOWN", "384382", "UNKNOWN");
        Dog targetByBreed = new Dog("UNKNOWN", "UNKNOWN", "Big Red Dog");
        Dog targetByAbsentBreed = new Dog("UNKNOWN", "UNKNOWN", "Tiny Red Dog");


        System.out.println("Looking for Snoopy by name.");
        System.out.println(DogSearcher.searchByName(dogs, targetSnoopy));

        System.out.println("Looking for a dog by ID.");
        System.out.println(DogSearcher.searchById(dogs, nameUnknown));

        DogComparator breedSearcher = (one, two) -> one.getBreed().compareTo(two.getBreed());
        System.out.println("Looking for a dog by breed.");
        System.out.println("Searching for: " + targetByBreed);
        System.out.println(DogSearcher.search(dogs, targetByBreed, breedSearcher));

        System.out.println("Searching for: " + targetByAbsentBreed);
        System.out.println(DogSearcher.search(dogs, targetByAbsentBreed, breedSearcher));


    }
}
